---
title: Developer Tools
tags:
- documentation
- tools
---
# Developer Tools

## IDE

We use the IDE's IntelliJ and PHPStorm from [Jetbrains](https://jetbrains.com), because we are convinced to use best toolset in the 
market so far.

## Debugging Drupal Code

### Add a PHP Server

First, you have to set up a Drupal environment with the tool [l3d](../docker/l3d/index.md). The tool is 
based on Docker containers.

Now navigate to File->Settings in your IDE and create a server:

![Screenshot](/files/screenshots/settings_php_new_server.png)

Set the following values:

![Screenshot](/files/screenshots/settings_php_add_server.png)

**Important: Always use Docker as name of your server.** 

Do not forget to add the file mapping to `/var/www/html`.

### Add a new Run/Debug Configuration

![Screenshot](/files/screenshots/configuration_add.png)

First create a new `PHP Web Page` configuration:

![Screenshot](/files/screenshots/configuration_new_webpage.png)

Set the following values:

![Screenshot](/files/screenshots/configuration_done.png)

Select the server you just have created.

**Important: Always use Docker as name of your configuration.** 

### Start Debugging

First, check the debug settings in your IDE. It should look something like this:

![Screenshot](/files/screenshots/settings_php_debug.png)

Now activate the `Phone` icon in your IDE:

![Screenshot](/files/screenshots/start_debug.png)

Now you can set your breakpoints and enjoy debugging Drupal code.

## Execute Drupal tests within your IDE


